/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.15 Revision 1.426
1# Copyright 1999-2002 Gentoo Technologies, Inc. 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# Author: Martin Schlemmer <azarah@gentoo.org>
4# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.15 2003/02/02 19:43:33 azarah Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.426 2013/09/13 11:22:52 mgorny Exp $
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9 4
10ECLASS=eutils 5# @ECLASS: eutils.eclass
11INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
12 7# base-system@gentoo.org
13newdepend "!bootstrap? ( sys-devel/patch )" 8# @BLURB: many extra (but common) functions that are used in ebuilds
14 9# @DESCRIPTION:
15DESCRIPTION="Based on the ${ECLASS} eclass" 10# The eutils eclass contains a suite of functions that complement
16 11# the ones that ebuild.sh already contain. The idea is that the functions
17# This function generate linker scripts in /usr/lib for dynamic 12# are not required in all ebuilds but enough utilize them to have a common
18# libs in /lib. This is to fix linking problems when you have 13# home rather than having multiple ebuilds implementing the same thing.
19# the .so in /lib, and the .a in /usr/lib. What happens is that
20# in some cases when linking dynamic, the .a in /usr/lib is used
21# instead of the .so in /lib due to gcc/libtool tweaking ld's
22# library search path. This cause many builds to fail.
23# See bug #4411 for more info.
24# 14#
25# To use, simply call: 15# Due to the nature of this eclass, some functions may have maintainers
26# 16# different from the overall eclass!
27# gen_usr_ldscript libfoo.so
28#
29# Note that you should in general use the unversioned name of
30# the library, as ldconfig should usually update it correctly
31# to point to the latest version of the library present.
32#
33# <azarah@gentoo.org> (26 Oct 2002)
34#
35gen_usr_ldscript() {
36 17
37 # Just make sure it exists 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
38 dodir /usr/lib 19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
39
40 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT"
41/* GNU ld script
42 Because Gentoo have critical dynamic libraries
43 in /lib, and the static versions in /usr/lib, we
44 need to have a "fake" dynamic lib in /usr/lib,
45 otherwise we run into linking problems.
46 See bug #4411 on http://bugs.gentoo.org/ for
47 more info. */
48GROUP ( /lib/libxxx )
49END_LDSCRIPT
50 20
51 dosed "s:libxxx:$1:" /usr/lib/$1 21inherit multilib toolchain-funcs user
52 22
23if has "${EAPI:-0}" 0 1 2; then
24
25# @FUNCTION: epause
26# @USAGE: [seconds]
27# @DESCRIPTION:
28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
29# printing a message the user should probably be reading and often used in
30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31# don't wait at all. Defined in EAPIs 0 1 and 2.
32epause() {
33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
34}
35
36# @FUNCTION: ebeep
37# @USAGE: [number of beeps]
38# @DESCRIPTION:
39# Issue the specified number of beeps (default of 5 beeps). Useful when
40# printing a message the user should probably be reading and often used in
41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42# don't beep at all. Defined in EAPIs 0 1 and 2.
43ebeep() {
44 local n
45 if [[ -z ${EBEEP_IGNORE} ]] ; then
46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
47 echo -ne "\a"
48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
49 echo -ne "\a"
50 sleep 1
51 done
52 fi
53}
54
55else
56
57ebeep() {
58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59}
60
61epause() {
62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63}
64
65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: evar_push
150# @USAGE: <variable to save> [more vars to save]
151# @DESCRIPTION:
152# This let's you temporarily modify a variable and then restore it (including
153# set vs unset semantics). Arrays are not supported at this time.
154#
155# This is meant for variables where using `local` does not work (such as
156# exported variables, or only temporarily changing things in a func).
157#
158# For example:
159# @CODE
160# evar_push LC_ALL
161# export LC_ALL=C
162# ... do some stuff that needs LC_ALL=C set ...
163# evar_pop
164#
165# # You can also save/restore more than one var at a time
166# evar_push BUTTERFLY IN THE SKY
167# ... do stuff with the vars ...
168# evar_pop # This restores just one var, SKY
169# ... do more stuff ...
170# evar_pop 3 # This pops the remaining 3 vars
171# @CODE
172evar_push() {
173 local var val
174 for var ; do
175 [[ ${!var+set} == "set" ]] \
176 && val=${!var} \
177 || val="${___ECLASS_ONCE_EUTILS}"
178 estack_push evar "${var}" "${val}"
179 done
180}
181
182# @FUNCTION: evar_push_set
183# @USAGE: <variable to save> [new value to store]
184# @DESCRIPTION:
185# This is a handy shortcut to save and temporarily set a variable. If a value
186# is not specified, the var will be unset.
187evar_push_set() {
188 local var=$1
189 evar_push ${var}
190 case $# in
191 1) unset ${var} ;;
192 2) printf -v "${var}" '%s' "$2" ;;
193 *) die "${FUNCNAME}: incorrect # of args: $*" ;;
194 esac
195}
196
197# @FUNCTION: evar_pop
198# @USAGE: [number of vars to restore]
199# @DESCRIPTION:
200# Restore the variables to the state saved with the corresponding
201# evar_push call. See that function for more details.
202evar_pop() {
203 local cnt=${1:-bad}
204 case $# in
205 0) cnt=1 ;;
206 1) isdigit "${cnt}" || die "${FUNCNAME}: first arg must be a number: $*" ;;
207 *) die "${FUNCNAME}: only accepts one arg: $*" ;;
208 esac
209
210 local var val
211 while (( cnt-- )) ; do
212 estack_pop evar val || die "${FUNCNAME}: unbalanced push"
213 estack_pop evar var || die "${FUNCNAME}: unbalanced push"
214 [[ ${val} == "${___ECLASS_ONCE_EUTILS}" ]] \
215 && unset ${var} \
216 || printf -v "${var}" '%s' "${val}"
217 done
218}
219
220# @FUNCTION: eshopts_push
221# @USAGE: [options to `set` or `shopt`]
222# @DESCRIPTION:
223# Often times code will want to enable a shell option to change code behavior.
224# Since changing shell options can easily break other pieces of code (which
225# assume the default state), eshopts_push is used to (1) push the current shell
226# options onto a stack and (2) pass the specified arguments to set.
227#
228# If the first argument is '-s' or '-u', we assume you want to call `shopt`
229# rather than `set` as there are some options only available via that.
230#
231# A common example is to disable shell globbing so that special meaning/care
232# may be used with variables/arguments to custom functions. That would be:
233# @CODE
234# eshopts_push -s noglob
235# for x in ${foo} ; do
236# if ...some check... ; then
237# eshopts_pop
238# return 0
239# fi
240# done
241# eshopts_pop
242# @CODE
243eshopts_push() {
244 if [[ $1 == -[su] ]] ; then
245 estack_push eshopts "$(shopt -p)"
246 [[ $# -eq 0 ]] && return 0
247 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
248 else
249 estack_push eshopts $-
250 [[ $# -eq 0 ]] && return 0
251 set "$@" || die "${FUNCNAME}: bad options to set: $*"
252 fi
253}
254
255# @FUNCTION: eshopts_pop
256# @USAGE:
257# @DESCRIPTION:
258# Restore the shell options to the state saved with the corresponding
259# eshopts_push call. See that function for more details.
260eshopts_pop() {
261 local s
262 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
263 if [[ ${s} == "shopt -"* ]] ; then
264 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
265 else
266 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
267 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
268 fi
269}
270
271# @FUNCTION: eumask_push
272# @USAGE: <new umask>
273# @DESCRIPTION:
274# Set the umask to the new value specified while saving the previous
275# value onto a stack. Useful for temporarily changing the umask.
276eumask_push() {
277 estack_push eumask "$(umask)"
278 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
279}
280
281# @FUNCTION: eumask_pop
282# @USAGE:
283# @DESCRIPTION:
284# Restore the previous umask state.
285eumask_pop() {
286 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
287 local s
288 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
289 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
290}
291
292# @FUNCTION: isdigit
293# @USAGE: <number> [more numbers]
294# @DESCRIPTION:
295# Return true if all arguments are numbers.
296isdigit() {
297 local d
298 for d ; do
299 [[ ${d:-bad} == *[!0-9]* ]] && return 1
300 done
53 return 0 301 return 0
54} 302}
55 303
56# Simple function to draw a line consisting of '=' the same length as $* 304# @VARIABLE: EPATCH_SOURCE
57# 305# @DESCRIPTION:
58# <azarah@gentoo.org> (11 Nov 2002) 306# Default directory to search for patches.
59#
60draw_line() {
61 local i=0
62 local str_length=""
63
64 # Handle calls that do not have args, or wc not being installed ...
65 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
66 then
67 echo "==============================================================="
68 return 0
69 fi
70
71 # Get the length of $*
72 str_length="$(echo -n "$*" | wc -m)"
73
74 while [ "$i" -lt "${str_length}" ]
75 do
76 echo -n "="
77
78 i=$((i + 1))
79 done
80
81 echo
82
83 return 0
84}
85
86# Default directory where patches are located
87EPATCH_SOURCE="${WORKDIR}/patch" 307EPATCH_SOURCE="${WORKDIR}/patch"
88# Default extension for patches 308# @VARIABLE: EPATCH_SUFFIX
309# @DESCRIPTION:
310# Default extension for patches (do not prefix the period yourself).
89EPATCH_SUFFIX="patch.bz2" 311EPATCH_SUFFIX="patch.bz2"
90# Default options for patch 312# @VARIABLE: EPATCH_OPTS
313# @DESCRIPTION:
314# Options to pass to patch. Meant for ebuild/package-specific tweaking
315# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
316# for single patch tweaking, you can also pass flags directly to epatch.
91EPATCH_OPTS="" 317EPATCH_OPTS=""
318# @VARIABLE: EPATCH_COMMON_OPTS
319# @DESCRIPTION:
320# Common options to pass to `patch`. You probably should never need to
321# change these. If you do, please discuss it with base-system first to
322# be sure.
323# @CODE
324# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
325# --no-backup-if-mismatch - do not leave .orig files behind
326# -E - automatically remove empty files
327# @CODE
328EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
329# @VARIABLE: EPATCH_EXCLUDE
330# @DESCRIPTION:
92# List of patches not to apply. Not this is only file names, 331# List of patches not to apply. Note this is only file names,
93# and not the full path .. 332# and not the full path. Globs accepted.
94EPATCH_EXCLUDE="" 333EPATCH_EXCLUDE=""
334# @VARIABLE: EPATCH_SINGLE_MSG
335# @DESCRIPTION:
95# Change the printed message for a single patch. 336# Change the printed message for a single patch.
96EPATCH_SINGLE_MSG="" 337EPATCH_SINGLE_MSG=""
338# @VARIABLE: EPATCH_MULTI_MSG
339# @DESCRIPTION:
340# Change the printed message for multiple patches.
341EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
342# @VARIABLE: EPATCH_FORCE
343# @DESCRIPTION:
344# Only require patches to match EPATCH_SUFFIX rather than the extended
345# arch naming style.
346EPATCH_FORCE="no"
347# @VARIABLE: EPATCH_USER_EXCLUDE
348# @DEFAULT_UNSET
349# @DESCRIPTION:
350# List of patches not to apply. Note this is only file names,
351# and not the full path. Globs accepted.
97 352
98# This function is for bulk patching, or in theory for just one 353# @FUNCTION: epatch
99# or two patches. 354# @USAGE: [options] [patches] [dirs of patches]
355# @DESCRIPTION:
356# epatch is designed to greatly simplify the application of patches. It can
357# process patch files directly, or directories of patches. The patches may be
358# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
359# the -p option as epatch will automatically attempt -p0 to -p4 until things
360# apply successfully.
100# 361#
101# It should work with .bz2, .gz, .zip and plain text patches. 362# If you do not specify any patches/dirs, then epatch will default to the
102# Currently all patches should be the same format. 363# directory specified by EPATCH_SOURCE.
103# 364#
104# You do not have to specify '-p' option to patch, as it will 365# Any options specified that start with a dash will be passed down to patch
105# try with -p0 to -p5 until it succeed, or fail at -p5. 366# for this specific invocation. As soon as an arg w/out a dash is found, then
367# arg processing stops.
106# 368#
107# Above EPATCH_* variables can be used to control various defaults, 369# When processing directories, epatch will apply all patches that match:
108# bug they should be left as is to ensure an ebuild can rely on 370# @CODE
109# them for. 371# if ${EPATCH_FORCE} != "yes"
110#
111# Patches are applied in current directory.
112#
113# Bulk Patches should preferibly have the form of:
114#
115# ??_${ARCH}_foo.${EPATCH_SUFFIX} 372# ??_${ARCH}_foo.${EPATCH_SUFFIX}
373# else
374# *.${EPATCH_SUFFIX}
375# @CODE
376# The leading ?? are typically numbers used to force consistent patch ordering.
377# The arch field is used to apply patches only for the host architecture with
378# the special value of "all" means apply for everyone. Note that using values
379# other than "all" is highly discouraged -- you should apply patches all the
380# time and let architecture details be detected at configure/compile time.
116# 381#
117# For example: 382# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
383# for patches to apply.
118# 384#
119# 01_all_misc-fix.patch.bz2 385# Refer to the other EPATCH_xxx variables for more customization of behavior.
120# 02_sparc_another-fix.patch.bz2
121#
122# This ensures that there are a set order, and you can have ARCH
123# specific patches.
124#
125# If you however give an argument to epatch(), it will treat it as a
126# single patch that need to be applied if its a file. If on the other
127# hand its a directory, it will set EPATCH_SOURCE to this.
128#
129# <azarah@gentoo.org> (10 Nov 2002)
130#
131epatch() { 386epatch() {
132 local PIPE_CMD="" 387 _epatch_draw_line() {
133 local STDERR_TARGET="${T}/$$.out" 388 # create a line of same length as input string
134 local PATCH_TARGET="${T}/$$.patch" 389 [[ -z $1 ]] && set "$(printf "%65s" '')"
135 local PATCH_SUFFIX="" 390 echo "${1//?/=}"
391 }
392
393 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
394
395 # First process options. We localize the EPATCH_OPTS setting
396 # from above so that we can pass it on in the loop below with
397 # any additional values the user has specified.
398 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
399 while [[ $# -gt 0 ]] ; do
400 case $1 in
401 -*) EPATCH_OPTS+=( "$1" ) ;;
402 *) break ;;
403 esac
404 shift
405 done
406
407 # Let the rest of the code process one user arg at a time --
408 # each arg may expand into multiple patches, and each arg may
409 # need to start off with the default global EPATCH_xxx values
410 if [[ $# -gt 1 ]] ; then
411 local m
412 for m in "$@" ; do
413 epatch "${m}"
414 done
415 return 0
416 fi
417
136 local SINGLE_PATCH="no" 418 local SINGLE_PATCH="no"
137 local x="" 419 # no args means process ${EPATCH_SOURCE}
420 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
138 421
139 if [ "$#" -gt 1 ] 422 if [[ -f $1 ]] ; then
140 then
141 eerror "Invalid arguments to epatch()"
142 die "Invalid arguments to epatch()"
143 fi
144
145 if [ -n "$1" -a -f "$1" ]
146 then
147 SINGLE_PATCH="yes" 423 SINGLE_PATCH="yes"
148 424 set -- "$1"
149 local EPATCH_SOURCE="$1" 425 # Use the suffix from the single patch (localize it); the code
426 # below will find the suffix for us
150 local EPATCH_SUFFIX="${1##*\.}" 427 local EPATCH_SUFFIX=$1
151 428
152 elif [ -n "$1" -a -d "$1" ] 429 elif [[ -d $1 ]] ; then
153 then 430 # We have to force sorting to C so that the wildcard expansion is consistent #471666.
154 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 431 evar_push_set LC_COLLATE C
432 # Some people like to make dirs of patches w/out suffixes (vim).
433 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
434 evar_pop
435
436 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
437 # Re-use EPATCH_SOURCE as a search dir
438 epatch "${EPATCH_SOURCE}/$1"
439 return $?
440
155 else 441 else
156 if [ ! -d ${EPATCH_SOURCE} ] 442 # sanity check ... if it isn't a dir or file, wtf man ?
443 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
444 echo
445 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
446 eerror
447 eerror " ${EPATCH_SOURCE}"
448 eerror " ( ${EPATCH_SOURCE##*/} )"
449 echo
450 die "Cannot find \$EPATCH_SOURCE!"
451 fi
452
453 # Now that we know we're actually going to apply something, merge
454 # all of the patch options back in to a single variable for below.
455 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
456
457 local PIPE_CMD
458 case ${EPATCH_SUFFIX##*\.} in
459 xz) PIPE_CMD="xz -dc" ;;
460 lzma) PIPE_CMD="lzma -dc" ;;
461 bz2) PIPE_CMD="bzip2 -dc" ;;
462 gz|Z|z) PIPE_CMD="gzip -dc" ;;
463 ZIP|zip) PIPE_CMD="unzip -p" ;;
464 *) ;;
465 esac
466
467 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
468
469 local x
470 for x in "$@" ; do
471 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
472 # didn't match anything, ignore continue on
473 [[ ! -f ${x} ]] && continue
474
475 local patchname=${x##*/}
476
477 # Apply single patches, or forced sets of patches, or
478 # patches with ARCH dependant names.
479 # ???_arch_foo.patch
480 # Else, skip this input altogether
481 local a=${patchname#*_} # strip the ???_
482 a=${a%%_*} # strip the _foo.patch
483 if ! [[ ${SINGLE_PATCH} == "yes" || \
484 ${EPATCH_FORCE} == "yes" || \
485 ${a} == all || \
486 ${a} == ${ARCH} ]]
157 then 487 then
488 continue
489 fi
490
491 # Let people filter things dynamically
492 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
493 # let people use globs in the exclude
494 eshopts_push -o noglob
495
496 local ex
497 for ex in ${EPATCH_EXCLUDE} ; do
498 if [[ ${patchname} == ${ex} ]] ; then
499 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
500 eshopts_pop
501 continue 2
502 fi
503 done
504
505 for ex in ${EPATCH_USER_EXCLUDE} ; do
506 if [[ ${patchname} == ${ex} ]] ; then
507 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
508 eshopts_pop
509 continue 2
510 fi
511 done
512
513 eshopts_pop
514 fi
515
516 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
517 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
518 einfo "${EPATCH_SINGLE_MSG}"
519 else
520 einfo "Applying ${patchname} ..."
521 fi
522 else
523 einfo " ${patchname} ..."
524 fi
525
526 # most of the time, there will only be one run per unique name,
527 # but if there are more, make sure we get unique log filenames
528 local STDERR_TARGET="${T}/${patchname}.out"
529 if [[ -e ${STDERR_TARGET} ]] ; then
530 STDERR_TARGET="${T}/${patchname}-$$.out"
531 fi
532
533 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
534
535 # Decompress the patch if need be
536 local count=0
537 local PATCH_TARGET
538 if [[ -n ${PIPE_CMD} ]] ; then
539 PATCH_TARGET="${T}/$$.patch"
540 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
541
542 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
543 echo
544 eerror "Could not extract patch!"
545 #die "Could not extract patch!"
546 count=5
547 break
548 fi
549 else
550 PATCH_TARGET=${x}
551 fi
552
553 # Check for absolute paths in patches. If sandbox is disabled,
554 # people could (accidently) patch files in the root filesystem.
555 # Or trigger other unpleasantries #237667. So disallow -p0 on
556 # such patches.
557 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
558 if [[ -n ${abs_paths} ]] ; then
559 count=1
560 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
561 fi
562 # Similar reason, but with relative paths.
563 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
564 if [[ -n ${rel_paths} ]] ; then
158 echo 565 echo
159 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 566 eerror "Rejected Patch: ${patchname} !"
567 eerror " ( ${PATCH_TARGET} )"
160 eerror 568 eerror
161 eerror " ${EPATCH_SOURCE}" 569 eerror "Your patch uses relative paths '../':"
570 eerror "${rel_paths}"
162 echo 571 echo
163 die "Cannot find \$EPATCH_SOURCE!" 572 die "you need to fix the relative paths in patch"
573 fi
574
575 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
576 local patch_cmd
577 # Handle aliased patch command #404447 #461568
578 local patch="patch"
579 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
580 while [[ ${count} -lt 5 ]] ; do
581 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
582
583 # Generate some useful debug info ...
584 (
585 _epatch_draw_line "***** ${patchname} *****"
586 echo
587 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
588 echo
589 _epatch_draw_line "***** ${patchname} *****"
590 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
591 ret=$?
592 echo
593 echo "patch program exited with status ${ret}"
594 exit ${ret}
595 ) >> "${STDERR_TARGET}"
596
597 if [ $? -eq 0 ] ; then
598 (
599 _epatch_draw_line "***** ${patchname} *****"
600 echo
601 echo "ACTUALLY APPLYING ${patchname} ..."
602 echo
603 _epatch_draw_line "***** ${patchname} *****"
604 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
605 ret=$?
606 echo
607 echo "patch program exited with status ${ret}"
608 exit ${ret}
609 ) >> "${STDERR_TARGET}"
610
611 if [ $? -ne 0 ] ; then
612 echo
613 eerror "A dry-run of patch command succeeded, but actually"
614 eerror "applying the patch failed!"
615 #die "Real world sux compared to the dreamworld!"
616 count=5
617 fi
618 break
164 fi 619 fi
165 620
166 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}" 621 : $(( count++ ))
622 done
623
624 # if we had to decompress the patch, delete the temp one
625 if [[ -n ${PIPE_CMD} ]] ; then
626 rm -f "${PATCH_TARGET}"
167 fi 627 fi
168 628
169 case ${EPATCH_SUFFIX##*\.} in 629 if [[ ${count} -ge 5 ]] ; then
170 bz2) 630 echo
171 PIPE_CMD="bzip2 -dc" 631 eerror "Failed Patch: ${patchname} !"
632 eerror " ( ${PATCH_TARGET} )"
633 eerror
634 eerror "Include in your bugreport the contents of:"
635 eerror
636 eerror " ${STDERR_TARGET}"
637 echo
638 die "Failed Patch: ${patchname}!"
639 fi
640
641 # if everything worked, delete the full debug patch log
642 rm -f "${STDERR_TARGET}"
643
644 # then log away the exact stuff for people to review later
645 cat <<-EOF >> "${T}/epatch.log"
646 PATCH: ${x}
647 CMD: ${patch_cmd}
648 PWD: ${PWD}
649
650 EOF
651 eend 0
652 done
653
654 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
655 : # everything worked
656}
657
658# @FUNCTION: epatch_user
659# @USAGE:
660# @DESCRIPTION:
661# Applies user-provided patches to the source tree. The patches are
662# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
663# of these three directories to exist will be the one to use, ignoring
664# any more general directories which might exist as well. They must end
665# in ".patch" to be applied.
666#
667# User patches are intended for quick testing of patches without ebuild
668# modifications, as well as for permanent customizations a user might
669# desire. Obviously, there can be no official support for arbitrarily
670# patched ebuilds. So whenever a build log in a bug report mentions that
671# user patches were applied, the user should be asked to reproduce the
672# problem without these.
673#
674# Not all ebuilds do call this function, so placing patches in the
675# stated directory might or might not work, depending on the package and
676# the eclasses it inherits and uses. It is safe to call the function
677# repeatedly, so it is always possible to add a call at the ebuild
678# level. The first call is the time when the patches will be
679# applied.
680#
681# Ideally, this function should be called after gentoo-specific patches
682# have been applied, so that their code can be modified as well, but
683# before calls to e.g. eautoreconf, as the user patches might affect
684# autotool input files as well.
685epatch_user() {
686 [[ $# -ne 0 ]] && die "epatch_user takes no options"
687
688 # Allow multiple calls to this function; ignore all but the first
689 local applied="${T}/epatch_user.log"
690 [[ -e ${applied} ]] && return 2
691
692 # don't clobber any EPATCH vars that the parent might want
693 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
694 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
695 EPATCH_SOURCE=${base}/${CTARGET}/${check}
696 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
697 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
698 if [[ -d ${EPATCH_SOURCE} ]] ; then
699 EPATCH_SOURCE=${EPATCH_SOURCE} \
172 PATCH_SUFFIX="bz2" 700 EPATCH_SUFFIX="patch" \
701 EPATCH_FORCE="yes" \
702 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
703 epatch
704 echo "${EPATCH_SOURCE}" > "${applied}"
705 return 0
706 fi
707 done
708 echo "none" > "${applied}"
709 return 1
710}
711
712# @FUNCTION: emktemp
713# @USAGE: [temp dir]
714# @DESCRIPTION:
715# Cheap replacement for when debianutils (and thus mktemp)
716# does not exist on the users system.
717emktemp() {
718 local exe="touch"
719 [[ $1 == -d ]] && exe="mkdir" && shift
720 local topdir=$1
721
722 if [[ -z ${topdir} ]] ; then
723 [[ -z ${T} ]] \
724 && topdir="/tmp" \
725 || topdir=${T}
726 fi
727
728 if ! type -P mktemp > /dev/null ; then
729 # system lacks `mktemp` so we have to fake it
730 local tmp=/
731 while [[ -e ${tmp} ]] ; do
732 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
733 done
734 ${exe} "${tmp}" || ${exe} -p "${tmp}"
735 echo "${tmp}"
736 else
737 # the args here will give slightly wierd names on BSD,
738 # but should produce a usable file on all userlands
739 if [[ ${exe} == "touch" ]] ; then
740 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
741 else
742 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
743 fi
744 fi
745}
746
747# @FUNCTION: edos2unix
748# @USAGE: <file> [more files ...]
749# @DESCRIPTION:
750# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
751# to remove all of these text utilities from DEPEND variables because this
752# is a script based solution. Just give it a list of files to convert and
753# they will all be changed from the DOS CRLF format to the UNIX LF format.
754edos2unix() {
755 [[ $# -eq 0 ]] && return 0
756 sed -i 's/\r$//' -- "$@" || die
757}
758
759# @FUNCTION: make_desktop_entry
760# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
761# @DESCRIPTION:
762# Make a .desktop file.
763#
764# @CODE
765# binary: what command does the app run with ?
766# name: the name that will show up in the menu
767# icon: the icon to use in the menu entry
768# this can be relative (to /usr/share/pixmaps) or
769# a full path to an icon
770# type: what kind of application is this?
771# for categories:
772# http://standards.freedesktop.org/menu-spec/latest/apa.html
773# if unset, function tries to guess from package's category
774# fields: extra fields to append to the desktop file; a printf string
775# @CODE
776make_desktop_entry() {
777 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
778
779 local exec=${1}
780 local name=${2:-${PN}}
781 local icon=${3:-${PN}}
782 local type=${4}
783 local fields=${5}
784
785 if [[ -z ${type} ]] ; then
786 local catmaj=${CATEGORY%%-*}
787 local catmin=${CATEGORY##*-}
788 case ${catmaj} in
789 app)
790 case ${catmin} in
791 accessibility) type="Utility;Accessibility";;
792 admin) type=System;;
793 antivirus) type=System;;
794 arch) type="Utility;Archiving";;
795 backup) type="Utility;Archiving";;
796 cdr) type="AudioVideo;DiscBurning";;
797 dicts) type="Office;Dictionary";;
798 doc) type=Documentation;;
799 editors) type="Utility;TextEditor";;
800 emacs) type="Development;TextEditor";;
801 emulation) type="System;Emulator";;
802 laptop) type="Settings;HardwareSettings";;
803 office) type=Office;;
804 pda) type="Office;PDA";;
805 vim) type="Development;TextEditor";;
806 xemacs) type="Development;TextEditor";;
807 esac
173 ;; 808 ;;
174 gz|Z|z) 809
175 PIPE_CMD="gzip -dc" 810 dev)
176 PATCH_SUFFIX="gz" 811 type="Development"
177 ;; 812 ;;
178 ZIP|zip) 813
179 PIPE_CMD="unzip -p" 814 games)
180 PATCH_SUFFIX="zip" 815 case ${catmin} in
816 action|fps) type=ActionGame;;
817 arcade) type=ArcadeGame;;
818 board) type=BoardGame;;
819 emulation) type=Emulator;;
820 kids) type=KidsGame;;
821 puzzle) type=LogicGame;;
822 roguelike) type=RolePlaying;;
823 rpg) type=RolePlaying;;
824 simulation) type=Simulation;;
825 sports) type=SportsGame;;
826 strategy) type=StrategyGame;;
827 esac
828 type="Game;${type}"
181 ;; 829 ;;
830
831 gnome)
832 type="Gnome;GTK"
833 ;;
834
835 kde)
836 type="KDE;Qt"
837 ;;
838
839 mail)
840 type="Network;Email"
841 ;;
842
843 media)
844 case ${catmin} in
845 gfx)
846 type=Graphics
847 ;;
848 *)
849 case ${catmin} in
850 radio) type=Tuner;;
851 sound) type=Audio;;
852 tv) type=TV;;
853 video) type=Video;;
854 esac
855 type="AudioVideo;${type}"
856 ;;
857 esac
858 ;;
859
860 net)
861 case ${catmin} in
862 dialup) type=Dialup;;
863 ftp) type=FileTransfer;;
864 im) type=InstantMessaging;;
865 irc) type=IRCClient;;
866 mail) type=Email;;
867 news) type=News;;
868 nntp) type=News;;
869 p2p) type=FileTransfer;;
870 voip) type=Telephony;;
871 esac
872 type="Network;${type}"
873 ;;
874
875 sci)
876 case ${catmin} in
877 astro*) type=Astronomy;;
878 bio*) type=Biology;;
879 calc*) type=Calculator;;
880 chem*) type=Chemistry;;
881 elec*) type=Electronics;;
882 geo*) type=Geology;;
883 math*) type=Math;;
884 physics) type=Physics;;
885 visual*) type=DataVisualization;;
886 esac
887 type="Education;Science;${type}"
888 ;;
889
890 sys)
891 type="System"
892 ;;
893
894 www)
895 case ${catmin} in
896 client) type=WebBrowser;;
897 esac
898 type="Network;${type}"
899 ;;
900
901 *)
902 type=
903 ;;
904 esac
905 fi
906 if [ "${SLOT}" == "0" ] ; then
907 local desktop_name="${PN}"
908 else
909 local desktop_name="${PN}-${SLOT}"
910 fi
911 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
912 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
913
914 # Don't append another ";" when a valid category value is provided.
915 type=${type%;}${type:+;}
916
917 eshopts_push -s extglob
918 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
919 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
920 ewarn "allowed in .desktop files if the value is not an absolute path."
921 icon=${icon%.@(xpm|png|svg)}
922 fi
923 eshopts_pop
924
925 cat <<-EOF > "${desktop}"
926 [Desktop Entry]
927 Name=${name}
928 Type=Application
929 Comment=${DESCRIPTION}
930 Exec=${exec}
931 TryExec=${exec%% *}
932 Icon=${icon}
933 Categories=${type}
934 EOF
935
936 if [[ ${fields:-=} != *=* ]] ; then
937 # 5th arg used to be value to Path=
938 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
939 fields="Path=${fields}"
940 fi
941 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
942
943 (
944 # wrap the env here so that the 'insinto' call
945 # doesn't corrupt the env of the caller
946 insinto /usr/share/applications
947 doins "${desktop}"
948 ) || die "installing desktop file failed"
949}
950
951# @FUNCTION: validate_desktop_entries
952# @USAGE: [directories]
953# @MAINTAINER:
954# Carsten Lohrke <carlo@gentoo.org>
955# @DESCRIPTION:
956# Validate desktop entries using desktop-file-utils
957validate_desktop_entries() {
958 if [[ -x /usr/bin/desktop-file-validate ]] ; then
959 einfo "Checking desktop entry validity"
960 local directories=""
961 for d in /usr/share/applications $@ ; do
962 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
963 done
964 if [[ -n ${directories} ]] ; then
965 for FILE in $(find ${directories} -name "*\.desktop" \
966 -not -path '*.hidden*' | sort -u 2>/dev/null)
967 do
968 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
969 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
970 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
971 done
972 fi
973 echo ""
974 else
975 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
976 fi
977}
978
979# @FUNCTION: make_session_desktop
980# @USAGE: <title> <command> [command args...]
981# @DESCRIPTION:
982# Make a GDM/KDM Session file. The title is the file to execute to start the
983# Window Manager. The command is the name of the Window Manager.
984#
985# You can set the name of the file via the ${wm} variable.
986make_session_desktop() {
987 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
988 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
989
990 local title=$1
991 local command=$2
992 local desktop=${T}/${wm:-${PN}}.desktop
993 shift 2
994
995 cat <<-EOF > "${desktop}"
996 [Desktop Entry]
997 Name=${title}
998 Comment=This session logs you into ${title}
999 Exec=${command} $*
1000 TryExec=${command}
1001 Type=XSession
1002 EOF
1003
1004 (
1005 # wrap the env here so that the 'insinto' call
1006 # doesn't corrupt the env of the caller
1007 insinto /usr/share/xsessions
1008 doins "${desktop}"
1009 )
1010}
1011
1012# @FUNCTION: domenu
1013# @USAGE: <menus>
1014# @DESCRIPTION:
1015# Install the list of .desktop menu files into the appropriate directory
1016# (/usr/share/applications).
1017domenu() {
1018 (
1019 # wrap the env here so that the 'insinto' call
1020 # doesn't corrupt the env of the caller
1021 local i j ret=0
1022 insinto /usr/share/applications
1023 for i in "$@" ; do
1024 if [[ -f ${i} ]] ; then
1025 doins "${i}"
1026 ((ret+=$?))
1027 elif [[ -d ${i} ]] ; then
1028 for j in "${i}"/*.desktop ; do
1029 doins "${j}"
1030 ((ret+=$?))
1031 done
1032 else
1033 ((++ret))
1034 fi
1035 done
1036 exit ${ret}
1037 )
1038}
1039
1040# @FUNCTION: newmenu
1041# @USAGE: <menu> <newname>
1042# @DESCRIPTION:
1043# Like all other new* functions, install the specified menu as newname.
1044newmenu() {
1045 (
1046 # wrap the env here so that the 'insinto' call
1047 # doesn't corrupt the env of the caller
1048 insinto /usr/share/applications
1049 newins "$@"
1050 )
1051}
1052
1053# @FUNCTION: _iconins
1054# @INTERNAL
1055# @DESCRIPTION:
1056# function for use in doicon and newicon
1057_iconins() {
1058 (
1059 # wrap the env here so that the 'insinto' call
1060 # doesn't corrupt the env of the caller
1061 local funcname=$1; shift
1062 local size dir
1063 local context=apps
1064 local theme=hicolor
1065
1066 while [[ $# -gt 0 ]] ; do
1067 case $1 in
1068 -s|--size)
1069 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1070 size=${2%%x*}
1071 else
1072 size=${2}
1073 fi
1074 case ${size} in
1075 16|22|24|32|36|48|64|72|96|128|192|256)
1076 size=${size}x${size};;
1077 scalable)
1078 ;;
1079 *)
1080 eerror "${size} is an unsupported icon size!"
1081 exit 1;;
1082 esac
1083 shift 2;;
1084 -t|--theme)
1085 theme=${2}
1086 shift 2;;
1087 -c|--context)
1088 context=${2}
1089 shift 2;;
182 *) 1090 *)
183 PIPE_CMD="cat" 1091 if [[ -z ${size} ]] ; then
184 PATCH_SUFFIX="patch" 1092 insinto /usr/share/pixmaps
185 ;; 1093 else
186 esac 1094 insinto /usr/share/icons/${theme}/${size}/${context}
187
188 if [ "${SINGLE_PATCH}" = "no" ]
189 then
190 einfo "Applying various patches (bugfixes/updates)..."
191 fi
192 for x in ${EPATCH_SOURCE}
193 do
194 # New ARCH dependant patch naming scheme...
195 #
196 # ???_arch_foo.patch
197 #
198 if [ -f ${x} ] && \
199 [ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ]
200 then
201 local count=0
202 local popts="${EPATCH_OPTS}"
203
204 if [ -n "${EPATCH_EXCLUDE}" ]
205 then
206 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
207 then
208 continue
209 fi
210 fi 1095 fi
211 1096
212 if [ "${SINGLE_PATCH}" = "yes" ] 1097 if [[ ${funcname} == doicon ]] ; then
213 then 1098 if [[ -f $1 ]] ; then
214 if [ -n "${EPATCH_SINGLE_MSG}" ] 1099 doins "${1}"
215 then 1100 elif [[ -d $1 ]] ; then
216 einfo "${EPATCH_SINGLE_MSG}" 1101 shopt -s nullglob
1102 doins "${1}"/*.{png,svg}
1103 shopt -u nullglob
217 else 1104 else
218 einfo "Applying ${x##*/}..." 1105 eerror "${1} is not a valid file/directory!"
1106 exit 1
219 fi 1107 fi
220 else 1108 else
221 einfo " ${x##*/}..." 1109 break
222 fi 1110 fi
1111 shift 1;;
1112 esac
1113 done
1114 if [[ ${funcname} == newicon ]] ; then
1115 newins "$@"
1116 fi
1117 ) || die
1118}
223 1119
224 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1120# @FUNCTION: doicon
225 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1121# @USAGE: [options] <icons>
1122# @DESCRIPTION:
1123# Install icon into the icon directory /usr/share/icons or into
1124# /usr/share/pixmaps if "--size" is not set.
1125# This is useful in conjunction with creating desktop/menu files.
1126#
1127# @CODE
1128# options:
1129# -s, --size
1130# !!! must specify to install into /usr/share/icons/... !!!
1131# size of the icon, like 48 or 48x48
1132# supported icon sizes are:
1133# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1134# -c, --context
1135# defaults to "apps"
1136# -t, --theme
1137# defaults to "hicolor"
1138#
1139# icons: list of icons
1140#
1141# example 1: doicon foobar.png fuqbar.svg suckbar.png
1142# results in: insinto /usr/share/pixmaps
1143# doins foobar.png fuqbar.svg suckbar.png
1144#
1145# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1146# results in: insinto /usr/share/icons/hicolor/48x48/apps
1147# doins foobar.png fuqbar.png blobbar.png
1148# @CODE
1149doicon() {
1150 _iconins ${FUNCNAME} "$@"
1151}
226 1152
227 # Allow for prefix to differ ... im lazy, so shoot me :/ 1153# @FUNCTION: newicon
228 while [ "${count}" -lt 5 ] 1154# @USAGE: [options] <icon> <newname>
229 do 1155# @DESCRIPTION:
230 # Generate some useful debug info ... 1156# Like doicon, install the specified icon as newname.
231 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1157#
232 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1158# @CODE
1159# example 1: newicon foobar.png NEWNAME.png
1160# results in: insinto /usr/share/pixmaps
1161# newins foobar.png NEWNAME.png
1162#
1163# example 2: newicon -s 48 foobar.png NEWNAME.png
1164# results in: insinto /usr/share/icons/hicolor/48x48/apps
1165# newins foobar.png NEWNAME.png
1166# @CODE
1167newicon() {
1168 _iconins ${FUNCNAME} "$@"
1169}
233 1170
234 if [ "${PATCH_SUFFIX}" != "patch" ] 1171# @FUNCTION: strip-linguas
235 then 1172# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
236 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1173# @DESCRIPTION:
237 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1174# Make sure that LINGUAS only contains languages that
1175# a package can support. The first form allows you to
1176# specify a list of LINGUAS. The -i builds a list of po
1177# files found in all the directories and uses the
1178# intersection of the lists. The -u builds a list of po
1179# files found in all the directories and uses the union
1180# of the lists.
1181strip-linguas() {
1182 local ls newls nols
1183 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1184 local op=$1; shift
1185 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1186 local d f
1187 for d in "$@" ; do
1188 if [[ ${op} == "-u" ]] ; then
1189 newls=${ls}
1190 else
1191 newls=""
1192 fi
1193 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1194 if [[ ${op} == "-i" ]] ; then
1195 has ${f} ${ls} && newls="${newls} ${f}"
238 else 1196 else
239 PATCH_TARGET="${x}" 1197 has ${f} ${ls} || newls="${newls} ${f}"
240 fi 1198 fi
241 1199 done
242 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1200 ls=${newls}
243 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1201 done
244 1202 else
245 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1203 ls="$@"
246 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1204 fi
247 1205
248 if [ "${PATCH_SUFFIX}" != "patch" ] 1206 nols=""
249 then 1207 newls=""
250 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1 1208 for f in ${LINGUAS} ; do
251 then 1209 if has ${f} ${ls} ; then
252 echo 1210 newls="${newls} ${f}"
253 eerror "Could not extract patch!" 1211 else
254 #die "Could not extract patch!" 1212 nols="${nols} ${f}"
255 count=5 1213 fi
1214 done
1215 [[ -n ${nols} ]] \
1216 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1217 export LINGUAS=${newls:1}
1218}
1219
1220# @FUNCTION: preserve_old_lib
1221# @USAGE: <libs to preserve> [more libs]
1222# @DESCRIPTION:
1223# These functions are useful when a lib in your package changes ABI SONAME.
1224# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1225# would break packages that link against it. Most people get around this
1226# by using the portage SLOT mechanism, but that is not always a relevant
1227# solution, so instead you can call this from pkg_preinst. See also the
1228# preserve_old_lib_notify function.
1229preserve_old_lib() {
1230 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1231 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1232 die "Invalid preserve_old_lib() usage"
1233 fi
1234 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1235
1236 # let portage worry about it
1237 has preserve-libs ${FEATURES} && return 0
1238
1239 local lib dir
1240 for lib in "$@" ; do
1241 [[ -e ${ROOT}/${lib} ]] || continue
1242 dir=${lib%/*}
1243 dodir ${dir} || die "dodir ${dir} failed"
1244 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1245 touch "${D}"/${lib}
1246 done
1247}
1248
1249# @FUNCTION: preserve_old_lib_notify
1250# @USAGE: <libs to notify> [more libs]
1251# @DESCRIPTION:
1252# Spit helpful messages about the libraries preserved by preserve_old_lib.
1253preserve_old_lib_notify() {
1254 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1255 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1256 die "Invalid preserve_old_lib_notify() usage"
1257 fi
1258
1259 # let portage worry about it
1260 has preserve-libs ${FEATURES} && return 0
1261
1262 local lib notice=0
1263 for lib in "$@" ; do
1264 [[ -e ${ROOT}/${lib} ]] || continue
1265 if [[ ${notice} -eq 0 ]] ; then
1266 notice=1
1267 ewarn "Old versions of installed libraries were detected on your system."
1268 ewarn "In order to avoid breaking packages that depend on these old libs,"
1269 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1270 ewarn "in order to remove these old dependencies. If you do not have this"
1271 ewarn "helper program, simply emerge the 'gentoolkit' package."
1272 ewarn
1273 fi
1274 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1275 done
1276}
1277
1278# @FUNCTION: built_with_use
1279# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1280# @DESCRIPTION:
1281#
1282# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1283#
1284# A temporary hack until portage properly supports DEPENDing on USE
1285# flags being enabled in packages. This will check to see if the specified
1286# DEPEND atom was built with the specified list of USE flags. The
1287# --missing option controls the behavior if called on a package that does
1288# not actually support the defined USE flags (aka listed in IUSE).
1289# The default is to abort (call die). The -a and -o flags control
1290# the requirements of the USE flags. They correspond to "and" and "or"
1291# logic. So the -a flag means all listed USE flags must be enabled
1292# while the -o flag means at least one of the listed IUSE flags must be
1293# enabled. The --hidden option is really for internal use only as it
1294# means the USE flag we're checking is hidden expanded, so it won't be found
1295# in IUSE like normal USE flags.
1296#
1297# Remember that this function isn't terribly intelligent so order of optional
1298# flags matter.
1299built_with_use() {
1300 local hidden="no"
1301 if [[ $1 == "--hidden" ]] ; then
1302 hidden="yes"
1303 shift
1304 fi
1305
1306 local missing_action="die"
1307 if [[ $1 == "--missing" ]] ; then
1308 missing_action=$2
1309 shift ; shift
1310 case ${missing_action} in
1311 true|false|die) ;;
1312 *) die "unknown action '${missing_action}'";;
1313 esac
1314 fi
1315
1316 local opt=$1
1317 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1318
1319 local PKG=$(best_version $1)
1320 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1321 shift
1322
1323 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1324 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1325
1326 # if the IUSE file doesn't exist, the read will error out, we need to handle
1327 # this gracefully
1328 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1329 case ${missing_action} in
1330 true) return 0;;
1331 false) return 1;;
1332 die) die "Unable to determine what USE flags $PKG was built with";;
1333 esac
1334 fi
1335
1336 if [[ ${hidden} == "no" ]] ; then
1337 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1338 # Don't check USE_EXPAND #147237
1339 local expand
1340 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1341 if [[ $1 == ${expand}_* ]] ; then
1342 expand=""
256 break 1343 break
1344 fi
1345 done
1346 if [[ -n ${expand} ]] ; then
1347 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1348 case ${missing_action} in
1349 true) return 0;;
1350 false) return 1;;
1351 die) die "$PKG does not actually support the $1 USE flag!";;
1352 esac
1353 fi
1354 fi
1355 fi
1356
1357 local USE_BUILT=$(<${USEFILE})
1358 while [[ $# -gt 0 ]] ; do
1359 if [[ ${opt} = "-o" ]] ; then
1360 has $1 ${USE_BUILT} && return 0
1361 else
1362 has $1 ${USE_BUILT} || return 1
1363 fi
1364 shift
1365 done
1366 [[ ${opt} = "-a" ]]
1367}
1368
1369# @FUNCTION: epunt_cxx
1370# @USAGE: [dir to scan]
1371# @DESCRIPTION:
1372# Many configure scripts wrongly bail when a C++ compiler could not be
1373# detected. If dir is not specified, then it defaults to ${S}.
1374#
1375# http://bugs.gentoo.org/73450
1376epunt_cxx() {
1377 local dir=$1
1378 [[ -z ${dir} ]] && dir=${S}
1379 ebegin "Removing useless C++ checks"
1380 local f p any_found
1381 while IFS= read -r -d '' f; do
1382 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1383 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1384 any_found=1
1385 break
1386 fi
1387 done
1388 done < <(find "${dir}" -name configure -print0)
1389
1390 if [[ -z ${any_found} ]]; then
1391 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1392 fi
1393 eend 0
1394}
1395
1396# @FUNCTION: make_wrapper
1397# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1398# @DESCRIPTION:
1399# Create a shell wrapper script named wrapper in installpath
1400# (defaults to the bindir) to execute target (default of wrapper) by
1401# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1402# libpaths followed by optionally changing directory to chdir.
1403make_wrapper() {
1404 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1405 local tmpwrapper=$(emktemp)
1406
1407 (
1408 echo '#!/bin/sh'
1409 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${chdir}"
1410 if [[ -n ${libdir} ]] ; then
1411 cat <<-EOF
1412 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1413 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1414 else
1415 export LD_LIBRARY_PATH="${libdir}"
1416 fi
1417 EOF
1418 fi
1419 # We don't want to quote ${bin} so that people can pass complex
1420 # things as ${bin} ... "./someprog --args"
1421 printf 'exec %s "$@"\n' "${bin}"
1422 ) > "${tmpwrapper}"
1423 chmod go+rx "${tmpwrapper}"
1424
1425 if [[ -n ${path} ]] ; then
1426 (
1427 exeinto "${path}"
1428 newexe "${tmpwrapper}" "${wrapper}"
1429 ) || die
1430 else
1431 newbin "${tmpwrapper}" "${wrapper}" || die
1432 fi
1433}
1434
1435# @FUNCTION: path_exists
1436# @USAGE: [-a|-o] <paths>
1437# @DESCRIPTION:
1438# Check if the specified paths exist. Works for all types of paths
1439# (files/dirs/etc...). The -a and -o flags control the requirements
1440# of the paths. They correspond to "and" and "or" logic. So the -a
1441# flag means all the paths must exist while the -o flag means at least
1442# one of the paths must exist. The default behavior is "and". If no
1443# paths are specified, then the return value is "false".
1444path_exists() {
1445 local opt=$1
1446 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1447
1448 # no paths -> return false
1449 # same behavior as: [[ -e "" ]]
1450 [[ $# -eq 0 ]] && return 1
1451
1452 local p r=0
1453 for p in "$@" ; do
1454 [[ -e ${p} ]]
1455 : $(( r += $? ))
1456 done
1457
1458 case ${opt} in
1459 -a) return $(( r != 0 )) ;;
1460 -o) return $(( r == $# )) ;;
1461 esac
1462}
1463
1464# @FUNCTION: in_iuse
1465# @USAGE: <flag>
1466# @DESCRIPTION:
1467# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1468# as necessary.
1469#
1470# Note that this function should not be used in the global scope.
1471in_iuse() {
1472 debug-print-function ${FUNCNAME} "${@}"
1473 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1474
1475 local flag=${1}
1476 local liuse=( ${IUSE} )
1477
1478 has "${flag}" "${liuse[@]#[+-]}"
1479}
1480
1481# @FUNCTION: use_if_iuse
1482# @USAGE: <flag>
1483# @DESCRIPTION:
1484# Return true if the given flag is in USE and IUSE.
1485#
1486# Note that this function should not be used in the global scope.
1487use_if_iuse() {
1488 in_iuse $1 || return 1
1489 use $1
1490}
1491
1492# @FUNCTION: usex
1493# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1494# @DESCRIPTION:
1495# Proxy to declare usex for package managers or EAPIs that do not provide it
1496# and use the package manager implementation when available (i.e. EAPI >= 5).
1497# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1498# otherwise echo [false output][false suffix] (defaults to "no").
1499if has "${EAPI:-0}" 0 1 2 3 4; then
1500 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1501fi
1502
1503# @FUNCTION: prune_libtool_files
1504# @USAGE: [--all|--modules]
1505# @DESCRIPTION:
1506# Locate unnecessary libtool files (.la) and libtool static archives
1507# (.a) and remove them from installation image.
1508#
1509# By default, .la files are removed whenever the static linkage can
1510# either be performed using pkg-config or doesn't introduce additional
1511# flags.
1512#
1513# If '--modules' argument is passed, .la files for modules (plugins) are
1514# removed as well. This is usually useful when the package installs
1515# plugins and the plugin loader does not use .la files.
1516#
1517# If '--all' argument is passed, all .la files are removed without
1518# performing any heuristic on them. You shouldn't ever use that,
1519# and instead report a bug in the algorithm instead.
1520#
1521# The .a files are only removed whenever corresponding .la files state
1522# that they should not be linked to, i.e. whenever these files
1523# correspond to plugins.
1524#
1525# Note: if your package installs both static libraries and .pc files
1526# which use variable substitution for -l flags, you need to add
1527# pkg-config to your DEPEND.
1528prune_libtool_files() {
1529 debug-print-function ${FUNCNAME} "$@"
1530
1531 local removing_all removing_modules opt
1532 for opt; do
1533 case "${opt}" in
1534 --all)
1535 removing_all=1
1536 removing_modules=1
1537 ;;
1538 --modules)
1539 removing_modules=1
1540 ;;
1541 *)
1542 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1543 esac
1544 done
1545
1546 local f
1547 local queue=()
1548 while IFS= read -r -d '' f; do # for all .la files
1549 local archivefile=${f/%.la/.a}
1550
1551 # The following check is done by libtool itself.
1552 # It helps us avoid removing random files which match '*.la',
1553 # see bug #468380.
1554 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1' "${f}"; then
1555 continue
1556 fi
1557
1558 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1559 local reason pkgconfig_scanned
1560 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1561
1562 if [[ ${snotlink} == yes ]]; then
1563
1564 # Remove static libs we're not supposed to link against.
1565 if [[ -f ${archivefile} ]]; then
1566 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1567 queue+=( "${archivefile}" )
1568 fi
1569
1570 # The .la file may be used by a module loader, so avoid removing it
1571 # unless explicitly requested.
1572 if [[ ${removing_modules} ]]; then
1573 reason='module'
1574 fi
1575
1576 else
1577
1578 # Remove .la files when:
1579 # - user explicitly wants us to remove all .la files,
1580 # - respective static archive doesn't exist,
1581 # - they are covered by a .pc file already,
1582 # - they don't provide any new information (no libs & no flags).
1583
1584 if [[ ${removing_all} ]]; then
1585 reason='requested'
1586 elif [[ ! -f ${archivefile} ]]; then
1587 reason='no static archive'
1588 elif [[ ! $(sed -nre \
1589 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1590 "${f}") ]]; then
1591 reason='no libs & flags'
1592 else
1593 if [[ ! ${pkgconfig_scanned} ]]; then
1594 # Create a list of all .pc-covered libs.
1595 local pc_libs=()
1596 if [[ ! ${removing_all} ]]; then
1597 local pc
1598 local tf=${T}/prune-lt-files.pc
1599 local pkgconf=$(tc-getPKG_CONFIG)
1600
1601 while IFS= read -r -d '' pc; do # for all .pc files
1602 local arg libs
1603
1604 # Use pkg-config if available (and works),
1605 # fallback to sed.
1606 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1607 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1608 libs=$(${pkgconf} --libs "${tf}")
1609 else
1610 libs=$(sed -ne 's/^Libs://p' "${pc}")
1611 fi
1612
1613 for arg in ${libs}; do
1614 if [[ ${arg} == -l* ]]; then
1615 if [[ ${arg} == '*$*' ]]; then
1616 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1617 eqawarn "(arg: ${arg})"
1618 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1619 fi
1620
1621 pc_libs+=( lib${arg#-l}.la )
1622 fi
1623 done
1624 done < <(find "${D}" -type f -name '*.pc' -print0)
1625
1626 rm -f "${tf}"
257 fi 1627 fi
1628
1629 pkgconfig_scanned=1
1630 fi # pkgconfig_scanned
1631
1632 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1633 fi # removal due to .pc
1634
1635 fi # shouldnotlink==no
1636
1637 if [[ ${reason} ]]; then
1638 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1639 queue+=( "${f}" )
258 fi 1640 fi
259 1641 done < <(find "${D}" -xtype f -name '*.la' -print0)
260 if patch ${popts} --dry-run -f -p${count} < ${PATCH_TARGET} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
261 then
262 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
263 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
264 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
265 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
266 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
267 1642
268 patch ${popts} -p${count} < ${PATCH_TARGET} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1 1643 if [[ ${queue[@]} ]]; then
1644 rm -f "${queue[@]}"
1645 fi
1646}
269 1647
270 if [ "$?" -ne 0 ] 1648einstalldocs() {
271 then 1649 debug-print-function ${FUNCNAME} "${@}"
272 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
273 echo
274 eerror "A dry-run of patch command succeeded, but actually"
275 eerror "applying the patch failed!"
276 #die "Real world sux compared to the dreamworld!"
277 count=5
278 fi
279 1650
280 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 1651 if ! declare -p DOCS &>/dev/null ; then
281 1652 local d
282 break 1653 for d in README* ChangeLog AUTHORS NEWS TODO CHANGES \
283 fi 1654 THANKS BUGS FAQ CREDITS CHANGELOG ; do
284 1655 [[ -s ${d} ]] && dodoc "${d}"
285 count=$((count + 1))
286 done 1656 done
287 1657 elif [[ $(declare -p DOCS) == "declare -a"* ]] ; then
288 if [ "${PATCH_SUFFIX}" != "patch" ] 1658 [[ ${DOCS[@]} ]] && dodoc -r "${DOCS[@]}"
289 then
290 rm -f ${PATCH_TARGET}
291 fi
292
293 if [ "${count}" -eq 5 ]
294 then
295 echo
296 eerror "Failed Patch: ${x##*/}!"
297 eerror
298 eerror "Include in your bugreport the contents of:"
299 eerror
300 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
301 echo
302 die "Failed Patch: ${x##*/}!"
303 fi
304
305 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
306
307 eend 0
308 fi
309 done
310 if [ "${SINGLE_PATCH}" = "no" ]
311 then
312 einfo "Done with patching"
313 fi
314}
315
316# This function check how many cpu's are present, and then set
317# -j in MAKEOPTS accordingly.
318#
319# Thanks to nall <nall@gentoo.org> for this.
320#
321get_number_of_jobs() {
322 local jobs=0
323
324 if [ ! -r /proc/cpuinfo ]
325 then
326 return 1
327 fi
328
329 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
330 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
331 then
332 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
333 ADMINPARAM="${ADMINOPTS##*-j}"
334 ADMINPARAM="${ADMINPARAM%% -*}"
335 fi
336
337 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j[0-9]*::g'`"
338
339 if [ "${ARCH}" = "x86" ]
340 then
341 # x86 always has "processor"
342 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
343
344 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
345 then
346 # sparc always has "ncpus active"
347 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
348
349 elif [ "${ARCH}" = "alpha" ]
350 then
351 # alpha has "cpus active", but only when compiled with SMP
352 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
353 then
354 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
355 else
356 jobs=2
357 fi
358
359 elif [ "${ARCH}" = "ppc" ]
360 then
361 # ppc has "processor", but only when compiled with SMP
362 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
363 then
364 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
365 else
366 jobs=2
367 fi
368 elif [ "${ARCH}" = "mips" ]
369 then
370 # mips always has "processor"
371 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
372
373 else 1659 else
374 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))" 1660 [[ ${DOCS} ]] && dodoc -r ${DOCS}
375 die "Unknown ARCH -- ${ARCH}!"
376 fi 1661 fi
377 1662
378 # Make sure the number is valid ... 1663 if [[ $(declare -p HTML_DOCS 2>/dev/null) == "declare -a"* ]] ; then
379 if [ "${jobs}" -lt 1 ] 1664 [[ ${HTML_DOCS[@]} ]] && dohtml -r "${HTML_DOCS[@]}"
380 then
381 jobs=1
382 fi
383
384 if [ -n "${ADMINPARAM}" ]
385 then
386 if [ "${jobs}" -gt "${ADMINPARAM}" ]
387 then
388 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
389 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
390 else 1665 else
391 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..." 1666 [[ ${HTML_DOCS} ]] && dohtml -r ${HTML_DOCS}
392 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
393 fi 1667 fi
1668
1669 return 0
1670}
1671
1672check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1673
394 fi 1674fi
395}
396

Legend:
Removed from v.1.15  
changed lines
  Added in v.1.426

  ViewVC Help
Powered by ViewVC 1.1.20